;;;   α׷ 1999 11 8
;;; øб GIS  庴

(defun GetPolyVtx(EntList / VtxList)
  (setq VtxList '())
  (foreach x EntList
    (if (= (car x) 10)
      (setq VtxList (append VtxList (list (cdr x))))
    )
  )
  VtxList
)

(defun c:INTCON(/ EntName1 EntName2 OldVarList)
  (setq OldVarList (list "OSMODE" "CMDECHO" "BLIPMODE"))
  (setq OldVarValue (mapcar 'getvar OldVarList))
  (mapcar 'setvar OldVarList '(0 0 0))

  (setq OldError *error*)
  (setq *error* ErrHandle)

  (command "undo" "be")
  
  (setq EntName1 (car (entsel "\nù°  : ")))
  (if (null EntName1)
    (progn
      (princ "  !")
      (exit)
    )
  )
  (redraw EntName1 3)

  (setq EntName2 (car (entsel "\nι°  : ")))
  (if (null EntName2)
    (progn
      (princ "  !")
      (exit)
    )
  )
  (redraw EntName2 3)

  (if DevNum
    (setq OldDevNum DevNum)
    (setq OldDevNum 5)
  )
  (setq DevNum (getint (strcat "\n  <"(itoa OldDevNum)">: ")))
  (if (null DevNum) (setq DevNum OldDevNum))
  (if (< DevNum 2)
    (progn
      (alert "2  ̻ ҵǾ մϴ.")
      (exit)
    )
  )
        
  (setq EntList1 (entget EntName1))
  (setq EntList2 (entget EntName2))

  (setq VtxList1 (GetPolyVtx EntList1))
  (setq VtxList2 (GetPolyVtx EntList2))

  (setq Pl1Start (car VtxList1)
        Pl2Start (car VtxList2)
        Pl2End (last VtxList2))

  (if (> (distance Pl1Start Pl2Start)
         (distance Pl1Start Pl2End))
    (setq VtxList2 (reverse VtxList2))
  )

  (setq VtxLen1 (length VtxList1))
  (setq VtxLen2 (length VtxList2))

  (setq Elev1 (cdr (assoc 38 EntList1)))
  (setq Elev2 (cdr (assoc 38 EntList2)))
  (setq SubElev (/ (- Elev2 Elev1) DevNum))
  
  (setq ResVtxList '())
  (setq i 0 NearVtxNum 0)
  (setq NearVtx (car VtxList2))
  (repeat VtxLen1
    (setq CrrVtx1 (nth i VtxList1))

    (setq SegList '())
    (setq MinDist 10000)
    (setq OldNearVtxNum NearVtxNum)
    (setq j NearVtxNum)
    (while (< j VtxLen2)
      (setq CrrVtx2 (nth j VtxList2))
      (if (< (distance CrrVtx1 CrrVtx2) MinDist)
        (setq NearVtxNum j MinDist (distance CrrVtx1 CrrVtx2))
      )
      (setq j (1+ j))
    )
    (setq NearVtx (nth NearVtxNum VtxList2))

    (if (and (/= i 0) (> NearVtxNum (1+ OldNearVtxNum)))
      (progn
        (setq Pt1 (nth (1- i) VtxList1))
        (setq Pt2 (nth i VtxList1))
        (setq k (1+ OldNearVtxNum))
        (while (< k NearVtxNum)
          (setq CrrVtx2 (nth k VtxList2))
          (if (<= (distance Pt1 CrrVtx2)
                 (distance Pt2 CrrVtx2))
;;;            (command "line" Pt1 CrrVtx2 "")
            (vtxDev Pt1 CrrVtx2)
;;;            (command "line" Pt2 CrrVtx2 "")
            (vtxDev Pt1 CrrVtx2)
          )
          (setq k (1+ k))
        )
      )
    )

;;;    (command "line" CrrVtx1 NearVtx "")
    (vtxDev CrrVtx1 NearVtx)
    (setq i (1+ i))
  )

  (setq NewVtxNum (/ (length ResVtxList) (1- DevNum)))

  (setq i 0)
  (repeat (1- DevNum)
    (setq CrrElev (+ Elev1 (* SubElev (1+ i))))
    (command "pline")
    (setq j 0)
    (repeat NewVtxNum
      (command (nth (+ (* (1- DevNum) j) i) ResVtxList))
      (setq j (1+ j))
    )
    (command "")
    (command "change" (entlast) "" "p"  "e" CrrElev "")
    (setq i (1+ i))
  )

  (redraw EntName1 4)
  (redraw EntName2 4)

  (command "undo" "e")
  (mapcar 'setvar OldVarList OldVarValue)
  
  (princ)
)

(defun VtxDev (Pt1 Pt2 / Ang Dist SubDist i)
  ;;  DevNum ResVtxList

  (setq Ang (angle Pt1 Pt2)
        Dist (distance Pt1 Pt2))

  (setq SubDist (/ Dist DevNum))

  (setq i 1)
  (repeat (1- DevNum)
    (setq ResVtxList (append ResVtxList (list (polar Pt1 Ang (* SubDist i)))))
    (setq i (1+ i))
  )
  VtxList
)

(defun ErrHandle (Err)
  (if EntName1 (redraw EntName1 4))
  (if EntName2 (redraw EntName2 4))

  (command "undo" "e")
  
  (if OldVarValue (mapcar 'setvar OldVarList OldVarValue))

  (if (and (/= Err "quit / exit abort")
           (/= Err "Function cancelled")
      )
    (princ Err)
  )

  (setq *error* OldError)
  (princ)
)

  
(princ "\n  α׷ - ɾ: INTCON")
(princ)